Attribute VB_Name = "CT_mod"
Option Compare Text
Public gConnection As ADODB.Connection

Public Function CT(inSql As String, Conn As ADODB.Connection) As String
'By Gert-Jan van der Kamp(gjvdkamp@hotmail.com), use as you like but leave these lines'
'This is a VB implementation of the article by Giuseppe Maxia

On Error GoTo CT_Handler

    Dim strTable As String, strColumn As String, strRow As String, strValue As String, strFunction As String
    Dim rstPivot As New ADODB.Recordset
    
    'interpret the TRANSFORM statement
    strTable = giveBetween(inSql, "FROM", "GROUP BY")
    strColumn = giveBetween(inSql, "PIVOT", ";")
    strRow = giveBetween(inSql, "GROUP BY", "PIVOT")
    strValue = giveBetween(inSql, "(", ")")
    strFunction = giveBetween(inSql, "TRANSFORM", "(")
       
    'check if everything was read ok
    If strTable = "" Or strColumn = "" Or strRow = "" Or strValue = "" Or strFunction = "" Then
        MsgBox "Can't read TRANSFORM statement, please check", vbExclamation, "Error"
        Exit Function
    End If
    
    'check if this function exists in mySQL
    If strFunction = "stdev" Or strFunction = "var" Then
        MsgBox strFunction & " is not implemented in mySQL yet.", vbOKOnly, "Sorry"
        Exit Function
    ElseIf strFunction = "First" Or strFunction = "last" Then
        MsgBox "We don't use " & strFunction & " in the real world, it's just wrong.(And it's not in mySQL anyway)", vbOKOnly, "NO!"
        Exit Function
    End If
       
    'everything looks good enough, let's go to work
    
    'get the columnames
    rstPivot.Open "SELECT DISTINCT " & strColumn & " FROM " & strTable & " ORDER BY " & strColumn & ";", Conn, adOpenForwardOnly, adLockReadOnly
    
    'create a query with all the columns
    strtemp = "SELECT " & strRow
    Do Until rstPivot.EOF
        If strFunction = "Count" Then
            strtemp = strtemp & ", SUM(IF(" & strColumn & " = '" & rstPivot(0) & "',1,0)) AS '" & rstPivot(0) & "'"
        Else
            strtemp = strtemp & ", " & strFunction & "(IF(" & strColumn & " = '" & rstPivot(0) & "'," & strValue & ",Null)) AS '" & rstPivot(0) & "'"
        End If
        rstPivot.MoveNext
    Loop
    
    'finish up
    strtemp = strtemp & " FROM " & strTable & " GROUP BY " & strRow & " ORDER BY " & strRow & ";"
    rstPivot.Close
    Set rstPivot = Nothing
    
    'voila
    CT = strtemp
Exit Function
CT_Handler:
MsgBox (Err.Description)
End Function

Private Function giveBetween(inString As String, Point1 As String, Point2 As String) As String
On Error Resume Next
    Dim a As Integer, b As Integer
    a = InStr(1, inString, Point1, vbTextCompare) + Len(Point1)
    b = InStr(1, inString, Point2, vbTextCompare)
    giveBetween = Trim(Mid(inString, a, b - a))
End Function


